CRC32C Class Reference

CRC-32C Checksum Calculation. More...

`#include <crc.h>`

Inheritance diagram for CRC32C:

## Public Member Functions

void | Update (const byte *input, size_t length)
| Updates a hash with additional input.
void | TruncatedFinal (byte *hash, size_t size)
| Computes the hash of the current message.
unsigned int | DigestSize () const
| Provides the digest size of the hash.
std::string | AlgorithmName () const
| Provides the name of this algorithm.
void | UpdateByte (byte b)
| Updates a CRC with additional input.
byte | GetCrcByte (size_t i) const
| Retrieves the i-th byte of the CRC.
std::string | AlgorithmProvider () const
| Retrieve the provider of this algorithm.
Public Member Functions inherited from HashTransformation
HashTransformation & | Ref ()
| Provides a reference to this object.
virtual byte * | CreateUpdateSpace (size_t &size)
| Request space which can be written into by the caller.
virtual void | Final (byte *digest)
| Computes the hash of the current message.
virtual void | Restart ()
| Restart the hash.
unsigned int | TagSize () const
| Provides the tag size of the hash.
virtual unsigned int | BlockSize () const
| Provides the block size of the compression function.
virtual unsigned int | OptimalBlockSize () const
| Provides the input block size most efficient for this hash.
virtual unsigned int | OptimalDataAlignment () const
| Provides input and output data alignment for optimal performance.
virtual void | CalculateDigest (byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message.
virtual bool | Verify (const byte *digest)
| Verifies the hash of the current message.
virtual bool | VerifyDigest (const byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message.
virtual void | CalculateTruncatedDigest (byte *digest, size_t digestSize, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message.
virtual bool | TruncatedVerify (const byte *digest, size_t digestLength)
| Verifies the hash of the current message.
virtual bool | VerifyTruncatedDigest (const byte *digest, size_t digestLength, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message.
Public Member Functions inherited from Algorithm
| Algorithm (bool checkSelfTestStatus=true)
| Interface for all crypto algorithms.
Public Member Functions inherited from Clonable
virtual Clonable * | Clone () const
| Copies this object.

## Static Public Member Functions

static const char * | StaticAlgorithmName ()

## Static Public Attributes

static const int | DIGESTSIZE = 4

## Detailed Description

CRC-32C Checksum Calculation.

Uses CRC polynomial 0x82F63B78

Since
  Crypto++ 5.6.4

Definition at line 58 of file crc.h.

## Constructor & Destructor Documentation

## CRC32C()

CRC32C::CRC32C | ( |  | ) |

Definition at line 314 of file crc.cpp.

## Member Function Documentation

## Update()

void CRC32C::Update | ( | const byte * | input,
|  | size_t | length )

virtual

Updates a hash with additional input.

Parameters

  input | the additional input as a buffer
  length | the size of the buffer, in bytes

Implements HashTransformation.

Definition at line 319 of file crc.cpp.

## TruncatedFinal()

void CRC32C::TruncatedFinal | ( | byte * | digest,
|  | size_t | digestSize )

virtual

Computes the hash of the current message.

Parameters

  digest | a pointer to the buffer to receive the hash
  digestSize | the size of the truncated digest, in bytes

TruncatedFinal() calls Final() and then copies digestSize bytes to digest. The hash is restarted the hash for the next message.

Precondition
  COUNTOF(digest) <= DigestSize() or COUNTOF(digest) <= HASH::DIGESTSIZE ensures the output byte buffer is a valid size.

Implements HashTransformation.

Definition at line 356 of file crc.cpp.

## DigestSize()

unsigned int CRC32C::DigestSize | ( |  | ) | const

inline virtual

Provides the digest size of the hash.

Returns
  the digest size of the hash.

Implements HashTransformation.

Definition at line 65 of file crc.h.

## StaticAlgorithmName()

const char * CRC32C::StaticAlgorithmName | ( |  | ) |

inline static

Definition at line 66 of file crc.h.

## AlgorithmName()

std::string CRC32C::AlgorithmName | ( |  | ) | const

inline virtual

Provides the name of this algorithm.

Returns
  the standard algorithm name

The standard algorithm name can be a name like AES or AES/GCM. Some algorithms do not have standard names yet. For example, there is no standard algorithm name for Shoup's ECIES.

Note
  AlgorithmName is not universally implemented yet.

Reimplemented from Algorithm.

Definition at line 67 of file crc.h.

## UpdateByte()

void CRC32C::UpdateByte | ( | byte | b | ) |

inline

Updates a CRC with additional input.

Parameters

  b | the additional input as a byte

Definition at line 71 of file crc.h.

## GetCrcByte()

byte CRC32C::GetCrcByte | ( | size_t | i | ) | const

inline

Retrieves the i-th byte of the CRC.

Parameters

  i | the additional input as a byte

Returns
  the byte at the i-th position

Definition at line 76 of file crc.h.

## AlgorithmProvider()

std::string CRC32C::AlgorithmProvider | ( |  | ) | const

virtual

Retrieve the provider of this algorithm.

Returns
  the algorithm provider

The algorithm provider can be a name like "C++", "SSE", "NEON", "AESNI", "ARMv8" and "Power8". C++ is standard C++ code. Other labels, like SSE, usually indicate a specialized implementation using instructions from a higher instruction set architecture (ISA). Future labels may include external hardware like a hardware security module (HSM).

Generally speaking Wei Dai's original IA-32 ASM code falls under "SSE2". Labels like "SSSE3" and "SSE4.1" follow after Wei's code and use intrinsics instead of ASM.

Algorithms which combine different instructions or ISAs provide the dominant one. For example on x86 AES/GCM returns "AESNI" rather than "CLMUL" or "AES+SSE4.1" or "AES+CLMUL" or "AES+SSE4.1+CLMUL".

Note
  Provider is not universally implemented yet.

Since
  Crypto++ 8.0

Reimplemented from Algorithm.

Definition at line 301 of file crc.cpp.

## Member Data Documentation

## DIGESTSIZE

const int CRC32C::DIGESTSIZE = 4

static

Definition at line 61 of file crc.h.

The documentation for this class was generated from the following files:

- crc.h
- crc.cpp